/*******************************************************************
*
*  DESCRIPTION: Atomic Model Display
*
*
*******************************************************************/

#ifndef __DISPLAY_
#define __DISPLAY_

#include <stdio.h> 
#include "atomic.h"     // class Atomic

class Display : public Atomic
{
public:
	Display( const string &name = "Display" );
	~Display();		

	virtual string className() const ;

protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );
	Model &loguearMensaje( const ExternalMessage & );
	void  openLogFile();

private:
	const  	Port &in;
	Time   	displayTime;  	// tiempo que se tarda en mostrar el mensaje 
        int    	cantMsgs;	// cantidad de mensajes que muestra el display
	string 	*msgs;		// array de mensajes	 
	int	idMensaje;	// id del mensaje que llega		
	FILE	*logFile;	// archivo de log 
	Model 	&_initArrayMsgs();
           

};	// class Display

// ** inline ** // 
inline
string Display::className() const
{
	return "Display" ;
}

#endif   //__DISPLAY_
