/*******************************************************************
*
*  DESCRIPTION: Atomic Model Generador
*
*
*******************************************************************/

#ifndef __GENERADOR_
#define __GENERADOR_

#include <stdio.h> 
#include "atomic.h"     // class Atomic

class Generador : public Atomic
{
public:
	Generador( const string &name = "Generador" );

	virtual string className() const ;

	typedef enum { pasivo, activando, devolver_dinero, 
	waiting, dando_vuelto, imprimiendo, actualizando_display } estado;

protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const  	Port &nuevo_boleto;		
	const  	Port &moneda_verificada;	
	const  	Port &cancelar;	
	  	Port &activar_vm;	
	  	Port &dar_vuelto;
	  	Port &impresion;
	  	Port &display;
	Time 	tout;		           
	int 	fase;		           
	float  nuevoBoleto, importeActual;


};	// class Generador

// ** inline ** // 
inline
string Generador::className() const
{
	return "Generador" ;
}

#endif   //__VERIFICADOR_
