/*******************************************************************
*
*  DESCRIPTION: Atomic Model Printer
*
*
*******************************************************************/

#ifndef __PRINTER_
#define __PRINTER_

#include <stdio.h> 
#include "atomic.h"     // class Atomic

class Printer : public Atomic
{
public:
	Printer( const string &name = "Printer" );

	virtual string className() const ;

	typedef enum { stoping, printing } estado;

protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );
	Model &loguearMensaje( const ExternalMessage & );
	void  openLogFile();

private:
	const  	Port &in;	// port de entrada de datos
	  	Port &stop;	// stop de la cola
	  	Port &done;	// ready de la cola
	Time   	printTime;  	// tiempo que se tarda en imprimir el mensaje 
	FILE	*logFile;	// archivo de log 
	int     idMensaje;	// id del mensaje que imprime
	int 	fase;		           

};	// class Printer

// ** inline ** // 
inline
string Printer::className() const
{
	return "Printer" ;
}

#endif   //__PRINTER_
