/*******************************************************************
*
*  DESCRIPTION: Simulator::registerNewAtomics()
*
*  AUTHOR: Amir Barylko & Jorge Beyoglonian 
*
*  EMAIL: mailto://amir@dc.uba.ar
*         mailto://jbeyoglo@dc.uba.ar
*
*  DATE: 27/6/1998
*
*******************************************************************/

#include "modeladm.h" 
#include "mainsimu.h"
#include "queue.h"      // class Queue
#include "generat.h"    // class Generator
#include "cpu.h"        // class CPU
#include "transduc.h"   // class Transducer
#include "trafico.h"    // class Trafico
#include "vuelto.h"     // class Vuelto
#include "display.h"    // class Display
#include "printer.h"    // class Printer
#include "verificador.h"    // class Verificador
#include "generador.h"    // class Generador


void MainSimulator::registerNewAtomics()
{
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Queue>() , "Queue" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Generator>() , "Generator" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<CPU>() , "CPU" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Transducer>() , "Transducer" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Trafico>() , "Trafico" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Vuelto>() , "Vuelto" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Display>() , "Display" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Printer>() , "Printer" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Verificador>() , "Verificador" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Generador>() , "Generador" ) ;
}
