/*******************************************************************
*
*  DESCRIPTION: Atomic Model Verificador
*
*
*******************************************************************/

#ifndef __VERIFICADOR_
#define __VERIFICADOR_

#include <stdio.h> 
#include "atomic.h"     // class Atomic

class Verificador : public Atomic
{
public:
	Verificador( const string &name = "Verificador" );

	virtual string className() const ;

	typedef enum { starting, stopping, waiting, verificar, verificando } estado;

protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const  	Port &in;		// port de entrada de datos
	const  	Port &activar_vm;	// port de activacion/desactivacion 
	  	Port &stop;	// stop de la cola
	  	Port &done;	// ready de la cola
	  	Port &moneda_verificada;	
	Time 	tout_verificacion;		           
	int 	fase;		           
	float   valorMoneda;

};	// class Verificador

// ** inline ** // 
inline
string Verificador::className() const
{
	return "Verificador" ;
}

#endif   //__VERIFICADOR_
