/*******************************************************************
*
*  DESCRIPTION: Atomic Model Vuelto
*
*
*******************************************************************/

#ifndef __VUELTO_H
#define __VUELTO_H

#include "atomic.h"     // class Atomic

class Vuelto : public Atomic
{
public:
	Vuelto( const string &name = "Vuelto" );					//Default constructor

	virtual string className() const ;
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &in;
	Port &vuelto;     // por este puerto salen las monedas del vuelto
	Port &resto;	  // por este puerto sale el valor del vuelto restante
	Time preparationTime;  // tiempo que se tarda en sacar la moneda

	int  stockMonedas;
	float valorMoneda;
	float acumVuelto;

};	// class Vuelto

// ** inline ** // 
inline
string Vuelto::className() const
{
	return "Vuelto" ;
}

#endif   //__VUELTO_H
